//////////////////////////////////////////////////////////////////////////////////////////////////////////
////MystyMood sky/sun/weather template...works without shader, uses 3dgs sky entitys!
////
////Note: All sky/weather values must be adjusted in this script...exept from the mysty_mood trigger values 
////that can be adjusted for each trigger dummy via the behaviour panel in WED.
////
////Jun 07 by www.loopix-project.com
////
////
////NEEDS: lens_flare.wdl (included after the sky entitiy definitions)
//////////////////////////////////////////////////////////////////////////////////////////////////////////

//include <lens_flare.wdl>;


////VALUES TO BE CHANGED TO YOUR NEEDS!


//****START SKY TWEAKABLES****//
////on/off for dynamic day elements/////////////////////////
var dynamic_day_night =		 1;//1=on, 0=off...for a moving sun...SET TO "0" WHEN IN IN SHADOW GENERATION MODE!

var sun_azimuth =			   190;//fix sun position when dynamic_day_night is set to "0"
var sun_elevation=			20;//fix sun position when dynamic_day_night is set to "0"

var use_moon = 				 1;//1=on, 0=off...wanna moon at night?
var use_lensflare =			 1;//1=on, 0=off...wanna cool lensflare effect?

var time_speed = 				30;//day-night transition speed
var time_speed_night =		50;//time_Speed during night (you can shorten the night!)

var use_bg_sounds = 			 1;//if 1, daytime ambiente background sounds are activated...else = 0
define snd_vol_rain_max, 				50;//sets the max volume of the rain sound
define snd_vol_wind_max, 				40;//sets the max volume of the wind sound when snowing
define snd_vol_wind_max_when_rainy, 10;//sets the max volume of the wind sound when raining
define snd_vol_bg_day_max, 80;//sets the max volume of the day ambient sound
define snd_vol_bg_night_max, 80;//sets the max volume of the day ambient sound

var use_underwater_sound =  1;//if 1, underwater sound is activated...else = 0

//set your desired daytime-fogcolors here!
//evening
var fog_mor[3] = 111,190,250;//b, g, r
//night
var fog_day[3] = 140,170,160;
//evening
var fog_eve[3] = 72,135,240;
//night
var fog_night[3] = 30,20,20;
//applied fogcolor when dynamic_day_night is deactivated
var fog_dynamic_day_night_off[3] = 160,170,160;//72,135,240;//
//underwater fog-color
var fog_underwater[3] = 140,120,70;

//be carefull with these...
var fog_fade_speed = 	    2;//...multiplied by time_speed
var sky_fade_speed = 	 0.03;

/////////////////////////////////////////////////////////////

//day sky
define sky_add_red, 		  255;//color tint of the day_sky.
define sky_add_green, 	  255;
define sky_add_blue, 	  255;
define sky_alpha, 		 	10;//0-100, decrease this to get more fogcolor1 tint

//night sky
define night_sky_scale_x, 	 0.5;//affects size of the stars at night
define night_sky_scale_y, 	 0.5;
define night_sky_speed_x,	 1;//movement speed of the stars
define night_sky_speed_y,	 1;
define night_sky_alpha,		 0;

//cloud layer 1
define cloud1_speed_x, 	  0.5;
define cloud1_speed_y, 	  	 3;
define cloud1_scale_x, 	  1.5;
define cloud1_scale_y, 	  1.5;
define cloud1_alpha, 	 	80;//alpha changes can cause various sun/clouds effects

//cloud layer 2
define cloud2_speed_x, 	  	 1;
define cloud2_speed_y, 	  	 5;
define cloud2_scale_x, 	  2.5;
define cloud2_scale_y, 	  2.5;
define cloud2_alpha, 	 	60;//alpha changes can cause various sun/clouds effects

//bad weather clouds
define cloud3_speed_x, 	  	 1;
define cloud3_speed_y, 	  	 5;
define cloud3_scale_x, 	  	 2;
define cloud3_scale_y, 	    2;
define cloud3_alpha, 	 	 0;//0 = starts at nice weather!

define max_zenith = 			50;//sets the max sun height (on it's path...when dynamic day/night cycle is on)

define sun_grow_z,		 1500;//z-height of sun-grow/sun-shrink, adjust according to your horizon view

//when your sun elevation is low, big scales (scale_x, scale_y) can look bad (sun-sprites touches the terrain!)
define sun_scale_x, 		    3;//7;////size of the sun, changes all other sun entitys (sun_corona, sun_shine) relative to it
define sun_scale_y, 		    3;//7;//

define sun_alpha, 		 	65;//alpha changes can cause various sun/clouds effects
define sun_corona_alpha, 	40;//0;//
define sun_shine_alpha,  	50;//0;//

var sunlight_fac=	  		    1;//affects the model and levelblock materials
var sun_col_fac=			  0.5;//factor of sun_color influence (sun_color is set to fogcolor)

define moon_scale_fac, 	  1.5;
define moon_alpha, 		  100;

define sun_dist_minus,	  1000;//evtl. raise this value when you see the sun flickering or disappear, default is 10 (10 quant before land_fog_far/clip_far)

define land_fog_near,	 200;//fog above water
define land_fog_far,	  	 4000;//lower values increase the framerate

define aqua_fog_near,	  -300;//negative near value for underwater fog (= WED fogcolor2)
define aqua_fog_far,	  	  600;

define weather_fog_near,	  100;//bad weather fog
define weather_fog_far,	  	  1000;
//****END SKY TWEAKABLES****//

//-------------------------------------------------------------------------------------------------//

//****START WEATHER TWEAKABLES****//
bmap* part_bmp_weather;
bmap bmp_rain = "rain.tga";
bmap bmp_snow = "snow.tga";

var part_vel_x;
var part_vel_y;
var part_vel_z;
var part_size;
var part_alpha;
var part_num; 

//define here the xyz size of the weatherbox around the camera
define cx,1000;//lenght
define cy,1000;//width
define cz,600;//height

//bad weather fog colors...night darker than day
var fog_weather_day[3] = 50,50,50;//r, g, b
var fog_weather_night[3] = 15,15,15;

var start_rain_snow = 0;//switch the particle-engine on/off

var use_random_weather = 1;//1= weather changes randomly
var random_weather_change_frequency = 100;//frequency of weather change...the higher the value the less it changes
var random_weather_state_time = 40;//the higher the value the longer a weather state remains

var weather_state = 0;//start with good weather...1=rain, 2=snow

var rain_wind_x = 2;
var rain_wind_y = 1;
var rain_fallspeed = 25;

var snow_wind_x = 4;
var snow_wind_y = 2;
var snow_fallspeed = 4;

var rain_to_snow_on_altitude = 1;//1=rain morphes to snow when snow_altitude is reached
var snow_altitude = 160;//world-coord-z that enables snowfall (in quants)

var rain_random_move_on = 1;//1=on,0=off...sets randomness on the particles x/y movement direction
var snow_random_move_on = 1;
var rain_random_move = 1;//strength of randomness on the particles x/y movement direction
var snow_random_move = 8;

define rain_part_num, 2;//defines rain density
define snow_part_num, 1;//defines snow density

var weather_fade_speed = 10;//fade-speed of weather change
var weather_soundfade_speed = 0.6;//fade-speed of weather-sound on weather changes

var disable_lightning_thunder = 0;//1=disables lightning-thunder
define lightning_frequency, 1.5;//random of 4000/lightning_frequency (wait)time
var lightning = 1;//x200...value to enlighten objects on ligtning strikes...use values 0.1-1
//****END WEATHER TWEAKABLES****//


////skills and flags for the mystymood triggers////
define trigg_rain, flag1;
define trigg_snow, flag2;
define trigg_disable_lightning_thunder, flag3;//1=disables lightning-thunder
define trigg_range, skill1;

define trigg_rain_wind_x, skill2;
define trigg_rain_wind_y, skill3;
define trigg_rain_fallspeed, skill4;

define trigg_snow_wind_x, skill5;
define trigg_snow_wind_y, skill6;
define trigg_snow_fallspeed, skill7;

define trigg_rain_random_move_on, flag4;//1=let the wind-strenght change randomly, 0=no wind-strenght changes
define trigg_snow_random_move_on, flag5;
define trigg_rain_random_move, skill8;//strength of randomness on the particles x/y movement direction
define trigg_snow_random_move, skill9;

define trigg_weather_fade_speed, skill10;//fade-speed of weather change

define trigg_fog_col_dist, flag6;//these are clear...
define trigg_fog_near, skill11;
define trigg_fog_far, skill12;
define trigg_fog_red, skill13;
define trigg_fog_green, skill14;
define trigg_fog_blue, skill15;

define trigg_ID, skill100;

var trigg_num_off = 0;
var trigg_active_id = -1;

var weather_fader = 1;//just an additional fader var
var fog_col_trigg[3];
var fog_dist_near_trigg;
var fog_dist_far_trigg;
var vel_wind_rain_x;
var vel_wind_rain_y;
var vel_wind_snow_x;
var vel_wind_snow_y;
////just some vars for the lightning-stroke
var stroke_area;//area of lightning stroke
var temporary;
var segment_length; // temporary length of the segment line
var segment_start; // starting point for the particle segment
var segment_end; // end of segment for the particle segment
var stroke_length; // temporary length of the particle line
var stroke_start; // the lightning effect starts here
var stroke_end; // the lightning effect ends here
////
var particle_seedbox[3];

var current_color[3];

var under_w;
var lightning_on;

//bmap bmp_rain = "rain.tga";    // change
//bmap bmp_snow = "snow.tga";    // change
bmap bmp_lightning = "lightning.tga";    // change

sound rain_wav = <rain.wav>;
sound wind_wav = <wind.wav>;
sound day_wav = <ambiente_day.wav>;
sound night_wav = <ambiente_night.wav>;
sound thunder1_wav = <thunder1.wav>;
sound thunder2_wav = <thunder2.wav>;
sound thunder3_wav = <thunder3.wav>;
sound thunder4_wav = <thunder4.wav>;
sound thunder5_wav = <thunder5.wav>;
sound underwater_wav = <underwater.wav>;


////start sky setup////
sky sky_horizon { //this is needed to fix the bad 3dgs horizon merging
	type = <horizon.tga>;
	layer = 5; 
	scale_x = 0.25;
	scale_y = 0.25;
	tilt = -60;//adjust this when you change sky_curve or sky_clip settings
	alpha = 100; 
	flags = scene,visible,transparent; 
}

sky sky_cloud1 { 
	type = <clouds.tga>;
	layer = 2;  
	speed_u = cloud1_speed_x; 
	speed_v = cloud1_speed_y; 
	scale_y = cloud1_scale_x; 
	scale_x = cloud1_scale_y; 
	tilt = -12;//-6; 
	flags = dome,visible,transparent; 
	alpha = cloud1_alpha; 
} 

sky sky_cloud2 { 
	type = <clouds.tga>;
	layer = 3;//4; 
	speed_u = cloud2_speed_x; 
	speed_v = cloud2_speed_y; 
	scale_x = cloud2_scale_x; 
	scale_y = cloud2_scale_y; 
	tilt = -10;//-5;
	flags = dome,visible,transparent; 
	alpha = cloud2_alpha; 
}

//bad weather clouds
sky sky_cloud3 { 
	type = <clouds_bad.tga>;
	layer = 4; 
	speed_u = cloud3_speed_x; 
	speed_v = cloud3_speed_y; 
	scale_x = cloud3_scale_x; 
	scale_y = cloud3_scale_y; 
	tilt = -10;//-5;
	flags = dome,transparent; 
	alpha = 0;//cloud3_alpha; 
}


sky sky_day { 
	type = <sky_day.tga>;
	layer = 1; 
	scale_x = 0.25;
	tilt = -20;//-10;
	red = sky_add_red;
	green = sky_add_green;
	blue = sky_add_blue;
	alpha = 60;//sky_alpha; 
	flags = scene,visible,transparent; 
}

sky sky_sun
{
	type = <sky_sun.tga>;//<lens_03.tga>;//
	layer = 6;
	alpha = sun_alpha;
	flags = facing,visible,transparent,bright;
}

sky sky_suncorona
{
	type = <sky_suncorona.tga>;
	layer = 3;
	alpha = sun_corona_alpha;
	flags = facing,visible,transparent,bright;
}

sky sky_sunshine
{
	type = <sky_sunshine.tga>;
	layer = 7;
	alpha = sun_shine_alpha;
	flags = facing,visible,transparent,bright;
}

sky sky_night { 
	type = <sky_night.tga>; 
	speed_u = night_sky_speed_x; 
	speed_v = night_sky_speed_y; 
	layer = 1; 
	alpha = 0;//night_sky_alpha; 
	flags = dome,visible,transparent; 
} 

sky sky_moon
{
	type = <sky_moon.tga>;
	layer = 2;
	alpha = moon_alpha;
	flags = facing,visible,transparent;
}
////end sky setup////

include <lens_flare.wdl>;

////fog-fade function////
function func_fade_colors(&col_target, &col1, &col2)
{
	var i = 0;
	if(i < 100)//while
	{
		i = min(i + fog_fade_speed*time_step, 100);
		vec_lerp(col_target, col1, col2, i/100);
		//        wait(1);
	}
}


//start rain/snow particle effects////

function func_init_part_weather()
{
	while(1){
		
		if(weather_state == 1){
			
			part_bmp_weather = bmp_rain;
			
			if(rain_random_move_on == 1){	
				part_vel_x = rain_wind_x + ((rain_random_move/2)-random(rain_random_move));
				part_vel_y = rain_wind_y + ((rain_random_move/2)-random(rain_random_move));	
			}
			else{
				part_vel_x = rain_wind_x;
				part_vel_y = rain_wind_y;
			}	
			part_vel_z = -rain_fallspeed;
			part_size=random(2)+8;
			part_alpha=random(10)+60;	
		}
		
		if(weather_state == 2){
			
			part_bmp_weather = bmp_snow;
			
			if(snow_random_move_on == 1){
				part_vel_x = snow_wind_x + ((snow_random_move/2)-random(snow_random_move));
				part_vel_y = snow_wind_y + ((snow_random_move/2)-random(snow_random_move));	
			}
			else{
				part_vel_x = snow_wind_x;
				part_vel_y = snow_wind_y;
			}	
			part_vel_z = -snow_fallspeed;
			part_size=random(1)+2;
			part_alpha=random(50)+40;	
		}
		wait(1);	
	}			
}

function func_particle_seed_infinity(){
	
	vec_set(my.x,vector(cycle(my.x,camera.x-particle_seedbox.x,camera.x+particle_seedbox.x),
	cycle(my.y,camera.y-particle_seedbox.y,camera.y+particle_seedbox.y),
	cycle(my.z,camera.z-particle_seedbox.z,camera.z+particle_seedbox.z)));
	
	if(my.z<camera.z-100 || my.z<water_level){my.lifespan=0;}
	
}

function func_effect_particle_seed(){

	vec_set(my.x,vector(camera.x+random(particle_seedbox.x*2)-particle_seedbox.x,
	camera.y+random(particle_seedbox.y*2)-particle_seedbox.y,
	camera.z+random(particle_seedbox.z*2)-particle_seedbox.z));
	
	my.move=on;
	
	if(sky_cloud3.alpha > 0){
		
		
		my.bmap = part_bmp_weather;
		
		my.vel_x = part_vel_x;
		my.vel_y = part_vel_y;
		my.vel_z = part_vel_z;
		//my.beam = on;
		my.size = part_size;
		my.alpha = part_alpha;
		
		my.function = func_particle_seed_infinity;	
	}	
}
////end rain/snow particle setup////


////start thunder lighning////
function func_fade_lightning()
{
	my.lifespan = 0;
}

function func_particle_lightning()
{
	temp.x = random(2) - 1;
	temp.y = random(2) - 1;
	temp.z = random(2) - 1;
	vec_set(my.vel_x, temp);
	my.bmap = bmp_lightning;
	my.size = 3;
	my.move = on;
	my.bright = on;
	my.flare = on;
	my.lifespan = 1;
	my.function = func_fade_lightning;
}

function func_particle_segment()
{
	vec_set(temporary, segment_end);
	vec_sub(segment_end, segment_start);
	segment_length = vec_length(segment_end);
	segment_end.x = (segment_end.x * 2) / segment_length; // create particles every 2. quant
	segment_end.y = (segment_end.y * 2) / segment_length;
	segment_end.z = (segment_end.z * 2) / segment_length;
	while(segment_length > 0)
	{
		effect(func_particle_lightning, 2, segment_start.x, nullvector);	
		vec_add(segment_start, segment_end);
		segment_length -= 2; // same value here
	}
}

function func_lightning_effect()
{
	vec_set(temporary, stroke_start);
	vec_sub(stroke_end, stroke_start);
	stroke_length = vec_length(stroke_end);
	stroke_end.x = (stroke_end.x * 100) / stroke_length; // create segments every 200 quants
	stroke_end.y = (stroke_end.y * 100) / stroke_length;
	stroke_end.z = (stroke_end.z * 100) / stroke_length;
	while(stroke_length > 0)
	{
		vec_add(stroke_start, stroke_end);
		vec_set(segment_start, temporary);
		vec_set(segment_end, stroke_start);
		segment_end.x += random(60) - 30; // displace the lightning segments (don't make the lightning look like a straight stroke)
		segment_end.y += random(60) - 30;
		segment_end.z += random(60) - 30;
		func_particle_segment();
		stroke_length -= 100; // keep the same value here
	}
}

function func_increase_brightness()
{
	lightning_on = 1;
	
	lightning = 255;
	wait(2+random(3));
	lightning = 1;
	wait(2+random(2));
	lightning = 255;
	wait(1+random(2));
	lightning = 1;
	wait(2+random(2));
	lightning = 255;
	wait(2+random(5));
	lightning = 1;
	
	wait(random(50));	
	lightning_on = 0;
}

function func_thunder_strike()
{
	var snd_handle_thunder;
	var rand_count;
	var rand_count_state;
	
	var outer_radius;
	var inner_radius;
	
	outer_radius = weather_fog_far;
	inner_radius = weather_fog_far-(weather_fog_far/8);


	while(1){
		
		randomize();
		
		rand_count = int(random(6));//creates a integer random number 0-4
		
		if(weather_state == 1 && disable_lightning_thunder == 0){
			
			func_increase_brightness();
			
			vec_set(temp,vector(inner_radius+random(outer_radius-inner_radius),0,0));
			vec_rotate(temp,vector(random(360),0,0));
			vec_add(temp,camera.x); //Camera.x is center now. Maybe you want "player.x" here or something different altogether, depending on your game
			//Temp now is a random position somewhere on your "ring"
			//In your case:
			vec_set(stroke_start.x,temp);
			stroke_start.z += 600;
			vec_set(stroke_end.x,vector(temp.x+random(100)-200,temp.y+random(100)-200,temp.z));
			stroke_end.z -= 200;
			
			func_lightning_effect();
			
			while(lightning_on>0){wait(1);}//thunder comes after lightning...
			
			if(rand_count == 1 && rand_count_state != 1){
				snd_handle_thunder = snd_play(thunder1_wav, 100, 0);
				rand_count_state = 1;
			}
			if(rand_count == 2 && rand_count_state != 2){
				snd_handle_thunder = snd_play(thunder2_wav, 100, 0);
				rand_count_state = 2;
			}
			if(rand_count == 3 && rand_count_state != 3){
				snd_handle_thunder = snd_play(thunder3_wav, 100, 0);
				rand_count_state = 3;	
			}
			if(rand_count == 4 && rand_count_state != 4){
				snd_handle_thunder = snd_play(thunder4_wav, 100, 0);
				rand_count_state = 4;	
			}
			if(rand_count == 5 && rand_count_state != 5){
				snd_handle_thunder = snd_play(thunder5_wav, 100, 0);
				rand_count_state = 5;	
			}	
		}
		
		if(rand_count>3){
			wait(random(4000/lightning_frequency));
		}
		else{
			if(rand_count == 1){
				wait(random(50));
			}
			if(rand_count == 2){
				wait(random(150));
			}
			if(rand_count == 3){
				wait(random(200));
			}
			
		}	
	}	
}
////end thunder lightning////


function func_random_weather()
{
	randomize();

	while(1){
		
		if(use_random_weather == 1){
			
			var i;
			i = random(random_weather_change_frequency);
			
			if(i>(random_weather_change_frequency/1.3)){
				weather_state = 1;
				wait(-(random(random_weather_state_time/2)+random_weather_state_time/2));	
			}
			if(i>(random_weather_change_frequency/1.3)){
				weather_state = 2;
				wait(-(random(random_weather_state_time/2)+random_weather_state_time/2));
			}	
			if(i>(random_weather_change_frequency/6)){
				weather_state = 0;
				wait(-(random(random_weather_state_time/2)+random_weather_state_time/2));
			}
		}	
		wait(1);
	}	
}

function toggle_weather()//just for testing
{
	weather_state += 1;

	if(weather_state > 2){
		weather_state = 0;
	}
}
function good_weather()//just for testing
{
	weather_state = 0;
}
on_space = toggle_weather;
on_alt = good_weather;


function weather_change(){

//	while(!ent_mystymood_trigg){wait(1);}

	func_init_part_weather();
	func_thunder_strike();
	func_random_weather();

	var snd_handle_rain;
	var snd_handle_wind;
	var snd_handle_bg_day;
	var snd_handle_bg_night;
	var snd_handle_underwater;

	var snd_vol_rain = 2;
	var snd_vol_wind = 2;
	var snd_vol_bg_day = 2;
	var snd_vol_bg_night = 2;
	var snd_vol_underwater = 100;
	
	var eff_density = 1;
	
	snd_handle_wind = snd_loop(wind_wav,snd_vol_wind,0);
	snd_handle_rain = snd_loop(rain_wav,snd_vol_rain,0);

	if(use_bg_sounds == 1){
		snd_handle_bg_day = snd_loop(day_wav,snd_vol_bg_day,0);
		snd_handle_bg_night = snd_loop(night_wav,snd_vol_bg_night,0);
	}
	if(use_underwater_sound == 1){
		snd_handle_underwater = snd_loop(underwater_wav,snd_vol_underwater,0);
	}
	
	weather_state = 0;//just a start default...
	
	while(1){
		
		particle_seedbox.x=cx/2;
		particle_seedbox.y=cy/2;
		particle_seedbox.z=cz/2;
		
		//		if(use_underwater_sound == 1){
			if(camera.z > 0){
				snd_vol_underwater = 2;	
			}
			else{
				snd_vol_wind = 2;
				snd_vol_rain = 2;
				snd_vol_bg_day = 2;
				snd_vol_bg_night = 2;
				
				snd_vol_underwater = 100;
			}
			
		//		}
		else{
			snd_stop(snd_vol_underwater);
		}	
		
		if(weather_state>0){
			
			sky_cloud3.visible = on;
			if (sky_cloud3.alpha < 90){sky_cloud3.alpha += weather_fade_speed/20*time_step;}
			
			if(sky_cloud3.alpha>40){
				if(weather_fader<100 && weather_state>0){
					weather_fader += weather_fade_speed/20*time_step;
				}
				if(weather_state == 0){
					if(weather_fader>1){
						weather_fader -= weather_fade_speed/20*time_step;
					}
				}
				
				eff_density = (weather_fader*part_num);
			}
			
			if(weather_state == 1){
				
				if(rain_to_snow_on_altitude == 1 && camera.z>snow_altitude && trigg_active_id == -1){
					weather_state = 2; 
				}	
				
				part_num = rain_part_num;
				
				if(snd_vol_bg_day>2 || snd_vol_bg_night>2){
					snd_vol_bg_day -= weather_soundfade_speed*time_step;
					snd_vol_bg_night -= weather_soundfade_speed*time_step;
				}	
				
				if(sky_cloud3.alpha>40){
					
					if(snd_vol_rain<snd_vol_rain_max){snd_vol_rain += weather_soundfade_speed*time_step;}
					if(snd_vol_wind<snd_vol_wind_max_when_rainy){snd_vol_wind += weather_soundfade_speed*time_step;}
					else{snd_vol_wind -= weather_soundfade_speed*time_step;}
					
					effect(func_effect_particle_seed,eff_density,nullvector,nullvector);
				}
			}	
			
			if(weather_state == 2){
				
				if(rain_to_snow_on_altitude == 1 && camera.z<snow_altitude && trigg_active_id == -1){
					
					weather_state = 1; 
				}	
				
				part_num = snow_part_num;
				
				if(sky_cloud3.alpha>40){
					
					if(snd_vol_rain>2){snd_vol_rain -= weather_soundfade_speed*time_step*2;}
					if(snd_vol_wind<snd_vol_wind_max){snd_vol_wind += (eff_density/50)*weather_soundfade_speed*time_step;}
					
					if(snd_vol_bg_day>2 || snd_vol_bg_night>2){
						snd_vol_bg_day -= weather_soundfade_speed*time_step;
						snd_vol_bg_night -= weather_soundfade_speed*time_step;
					}
					
					effect(func_effect_particle_seed,eff_density,nullvector,nullvector);
				}
			}
			
			if(trigg_active_id < 0){
				
				if(camera.fog_start>weather_fog_near){
					camera.fog_start -= weather_fade_speed*time_step;
				}
				else{
					camera.fog_start += weather_fade_speed*time_step;
				}
				if(camera.fog_end>weather_fog_far){
					camera.fog_end -= weather_fade_speed*time_step;
				}
				else{
					camera.fog_end += weather_fade_speed*time_step;
				}
			}
			
			
		}
		
		if(weather_state == 0){
			
			if(sky_cloud3.alpha > 1){
				sky_cloud3.alpha -= weather_fade_speed/60*time_step;
			}
			if(sky_cloud3.alpha<1){
				sky_cloud3.visible = off;
				
			}
			
			if(sky_cloud3.alpha > 40){
				
				if(snd_vol_rain>2 || snd_vol_wind>2){
					snd_vol_rain -= weather_soundfade_speed*time_step;
					snd_vol_wind -= weather_soundfade_speed*time_step;
					
					effect(func_effect_particle_seed,eff_density/4,nullvector,nullvector);
				}		
			}
			
			if(sky_cloud3.alpha < 60){
				
				if(sun_angle.pan > 160 && sun_angle.pan < 360){
					if(snd_vol_bg_night<snd_vol_bg_night_max){
						snd_vol_bg_night += weather_soundfade_speed*time_step;
						if(snd_vol_bg_day > 2){
							snd_vol_bg_day -= weather_soundfade_speed*time_step;
						}
					}			
				}
				
				if(sun_angle.pan>0 && sun_angle.pan<160){
					
					if(snd_vol_bg_day<snd_vol_bg_day_max){
						snd_vol_bg_day += weather_soundfade_speed*time_step;
						if(snd_vol_bg_night > 2){
							snd_vol_bg_night -= weather_soundfade_speed*time_step;
						}
					}	
				}
			}
			
			if(trigg_active_id < 0){
				
				if(camera.fog_start>land_fog_near){
					camera.fog_start -= weather_fade_speed*time_step;
				}
				else{
					camera.fog_start += weather_fade_speed*time_step;
				}
				if(camera.fog_end>land_fog_far){
					camera.fog_end -= weather_fade_speed*time_step;
				}
				else{
					camera.fog_end += weather_fade_speed*time_step;
				}
			}	
		}
		
		sky_sun.alpha = clamp((90-sky_cloud3.alpha),2,100);
		
		
		snd_tune(snd_handle_rain,snd_vol_rain,0,0);
		snd_tune(snd_handle_wind,snd_vol_wind,0,0);	
		snd_tune(snd_handle_bg_day,snd_vol_bg_day,0,0);
		snd_tune(snd_handle_bg_night,snd_vol_bg_night,0,0);
		snd_tune(snd_handle_underwater,snd_vol_underwater,0,0);
		
		wait(1);		
	}	
}


////////SKY AND CLOUD FADINGS////////
function sky_day_fade_in()
{

	if (sky_cloud1.alpha < 80){sky_cloud1.alpha += sky_fade_speed*time_step*time_speed;} 
	if (sky_cloud2.alpha < 60){sky_cloud2.alpha += sky_fade_speed*time_step*time_speed;}
	if (sky_day.alpha < 60){sky_day.alpha += sky_fade_speed*time_step*time_speed;}
	if (sky_night.alpha > 1){sky_night.alpha -= sky_fade_speed*time_step*time_speed;}	
}

function sky_day_state()
{
	sky_cloud1.alpha = 80;
	sky_cloud2.alpha = 60;
	sky_day.alpha = 60;
	sky_night.alpha = 1;
}

function sky_night_fade_in()
{

	if (sky_cloud1.alpha > 10){sky_cloud1.alpha -= sky_fade_speed*time_step*time_speed;} 
	if (sky_cloud2.alpha > 10){sky_cloud2.alpha -= sky_fade_speed*time_step*time_speed;} 
	if (sky_night.alpha < 100){sky_night.alpha += sky_fade_speed*time_step*time_speed;}
	if (sky_day.alpha > 1){sky_day.alpha -= sky_fade_speed*time_step*time_speed;}	
}

function sky_night_state()
{
	sky_cloud1.alpha = 10;
	sky_cloud2.alpha = 10;
	sky_day.alpha = 10;
	sky_night.alpha = 100;
}


starter main_sky{

	wait(10);

	if(use_lensflare == 1){
		lensflare_start();
	}

	////weather function
	weather_change();//weather change

	camera.arc = 60;//adjust this to get the desired field of view

	sky_curve = 2;//0...unlimited
	sky_clip = -10;//-90...90

	sun_light = 100*sunlight_fac;

	sky_sun.scale_x = sun_scale_x;
	sky_sun.scale_y = sun_scale_y;

	camera.fog_start = land_fog_near;//-50;
	camera.fog_end = land_fog_far;//300;

	vec_set(d3d_fogcolor1,fog_day);//set the default day fog-color 
	vec_set(d3d_fogcolor2,fog_underwater);//set the underwater fog-color 

	while(1){
		
		
		if(camera.z<water_level){//when underwater
			fog_color = 2;
			
			vec_set(sun_color.blue,vector(d3d_fogcolor2.blue*sun_col_fac,d3d_fogcolor2.green*sun_col_fac,d3d_fogcolor2.red*sun_col_fac));
			vec_set(bg_color.blue,d3d_fogcolor2.blue);	
			vec_set(sky_horizon.blue,d3d_fogcolor2.blue);
			
			camera.fog_start = aqua_fog_near;//-50;
			camera.fog_end = aqua_fog_far;//300;
			
			under_w = 1;
		}
		else{//when above water
			
			if(under_w == 1){
				camera.fog_start = land_fog_near;
				camera.fog_end = land_fog_far;
				
				under_w = 0;
			}
			
			fog_color = 1;
			
			vec_set(sun_color.blue,vector(d3d_fogcolor1.blue*sun_col_fac,d3d_fogcolor1.green*sun_col_fac,d3d_fogcolor1.red*sun_col_fac));
			vec_set(bg_color.blue,d3d_fogcolor1.blue);	
			vec_set(sky_horizon.blue,d3d_fogcolor1.blue);
			
			if(weather_state == 0 && trigg_active_id < 0){
				
				if(dynamic_day_night==0){
					func_fade_colors(d3d_fogcolor1,current_color,fog_dynamic_day_night_off);
				}
				
				if(camera.fog_start>land_fog_near){
					camera.fog_start -= weather_fade_speed*time_step;
				}
				else{
					camera.fog_start += weather_fade_speed*time_step;
				}
				if(camera.fog_end>land_fog_far){
					camera.fog_end -= weather_fade_speed*time_step;
				}
				else{
					camera.fog_end += weather_fade_speed*time_step;
				}	
			}	
		}
		
		vec_set(current_color,d3d_fogcolor1);
		
		camera.clip_near = 0; 
		camera.clip_far = land_fog_far+10;//camera.fog_end+10;//
		
		vec_set(temp,sun_pos); 
		vec_set(sky_sun.x,temp);  // copy the sun_pos location
		vec_sub(temp,camera.x); // direction vector from camera to our sun_pos
		vec_normalize(temp,land_fog_far-sun_dist_minus); // chop our direction vector to a set distance	
		
		vec_set(sky_sun.x,temp);
		
		if(use_moon == 1){
			
			vec_set(temp,sky_sun.x); 
			vec_inverse(temp);
			vec_set(sky_moon.x,temp);  // copy the sun_pos location
		}
		
		if(dynamic_day_night==1){
			
			if(sun_angle.pan > 230 && sun_angle.pan < 360){sun_angle.pan += 0.01*time_speed_night*time_step;}
			else{sun_angle.pan += 0.01*time_speed*time_step;}
			
			sun_angle.pan %= 360;
			sun_angle.tilt = fsin(sun_angle.pan, max_zenith);
			
			//sun "grows" at low azimut
			if(sky_sun.z<sun_grow_z){
				if(sky_sun.scale_x<sun_scale_x+1 && sky_sun.scale_y<sun_scale_y+1){
					sky_sun.scale_x += 0.01*time_step*time_speed/10;
					sky_sun.scale_y += 0.01*time_step*time_speed/10;
				}	
			}
			else{
				if(sky_sun.scale_x>sun_scale_x && sky_sun.scale_y>sun_scale_y){
					sky_sun.scale_x -= 0.01*time_step*time_speed/10;
					sky_sun.scale_y -= 0.01*time_step*time_speed/10;
				}
			}
		}
		else{
			sun_angle.pan = sun_azimuth;
			sun_angle.tilt = sun_elevation;
		}
		
		
		if(sun_angle.pan > 0 && sun_angle.pan < 40){
			sky_day_fade_in();
		}	
		if(sun_angle.pan > 10 && sun_angle.pan < 160){
			func_fade_colors(d3d_fogcolor1,current_color,fog_day);	
		}
		if(sun_angle.pan > 40 && sun_angle.pan < 160){	
			sky_day_state();
		}	
		if(sun_angle.pan > 160 && sun_angle.pan < 190){
			sky_night_fade_in();
			func_fade_colors(d3d_fogcolor1,current_color,fog_eve);
		}
		if(sun_angle.pan > 190 && sun_angle.pan < 340){
			func_fade_colors(d3d_fogcolor1,current_color,fog_night);
		}
		if(sun_angle.pan > 190 && sun_angle.pan < 340){	
			sky_night_state();
		}	
		if(sun_angle.pan > 340 && sun_angle.pan < 360){
			func_fade_colors(d3d_fogcolor1,current_color,fog_mor);
		}
		
		if(sun_angle.pan > 190 && sun_angle.pan < 350){
			if(weather_state>0){
				func_fade_colors(d3d_fogcolor1,current_color,fog_weather_night);
			}
		}
		else{
			if(weather_state>0){
				func_fade_colors(d3d_fogcolor1,current_color,fog_weather_day);
			}
		}
		
		vec_set(sky_sunshine.x,sky_sun.x);	
		vec_set(sky_suncorona.x,sky_sun.x);
		
		sky_suncorona.scale_x = sun_scale_x*5;//15;
		sky_suncorona.scale_y = sun_scale_y*4;//7;
		
		sky_sunshine.scale_x = sun_scale_x*10;
		sky_sunshine.scale_y = sun_scale_y*4;
		
		sky_moon.scale_x = sun_scale_x*moon_scale_fac;
		sky_moon.scale_y = sun_scale_y*moon_scale_fac;	 
		
		sky_night.scale_x = night_sky_scale_x;
		sky_night.scale_y = night_sky_scale_y;
		
		wait(1);
	}	
}

//title:MystyMood Sky Template
//image:loopix_logo.pcx
//action:act_mystymood_trigg  
//skill1:trigg_range 300.000
//help: sets  range within the mood-trigger is activated
//skill2:trigg_rain_wind_x 2.000
//help: wind strenght on direction x
//skill3:trigg_rain_wind_y 0.000
//help:  wind strenght on direction y
//skill4:trigg_rain_fallspeed 20.000
//help: fallingspeed of the raindrops
// section:
//skill5:trigg_snow_wind_x 4.000
//help: wind strenght on direction x
//skill6:trigg_snow_wind_y 0.000
//help: wind strenght on direction y
//skill7:trigg_snow_fallspeed 5.000
//help: fallingspeed of the snowflakes
// section:
//skill8:trigg_rain_random_move 2.000
//help: random-xy movement of the rain particle
//skill9:trigg_snow_random_move 4.000
//help: random-xy movement of the snow particle
// section:
//skill10:trigg_weather_fade_speed 10.000
//help: speed of fading one weather/mood state into the next
//section:
//skill11:trigg_fog_near 0.000
//help: sets the fog_near distance...use negative values for starting the fog behind the camera
//skill12:trigg_fog_far 0.000
//help: sets the fog_far distance
//skill13: trigg_fog_red 140.000
//help: fog color red
//skill14: trigg_fog_green 170.000
//help: fog color green
//skill15: trigg_fog_blue 160.000
//help: fog color blue
//section:
//text: flag to enable rain
//flag1:trigg_rain 0.000
//text: flag to enable snow
//flag2:trigg_snow 0.000
//text: flag to disable lightning and thunder
//flag3:trigg_disable_lightning_thunder
// section:
//text: flag to enable random-xy movement of the rain particle
//flag4:trigg_rain_random_move_on 1.000
//text: flag to enable random-xy movement of the snow particle
//flag5:trigg_snow_random_move_on 1.000
// section:
//text: flag to enable fog distance/density change
//flag6:trigg_fog_col_dist 1.000
//uses:trigg_range,trigg_rain,trigg_snow,trigg_rain_wind_x,trigg_rain_wind_y,trigg_rain_fallspeed
//uses:trigg_snow_wind_x,trigg_snow_wind_y,trigg_snow_fallspeed
//uses:trigg_rain_random_move_on,trigg_snow_random_move_on,trigg_rain_random_move,trigg_snow_random_move
//uses:trigg_weather_fade_speed,trigg_disable_lightning_thunder
//uses:trigg_fog_col_dist,trigg_fog_near,trigg_fog_far,trigg_fog_red,trigg_fog_green,trigg_fog_blue
action act_mystymood_trigg
{
	act_mystymood_trigg_label2:
	
	ent_mystymood_trigg = me;
	
	//	my.invisible = on;
	my.passable = on;
	
	//set default skills
	if(!my.trigg_range){my.trigg_range = 300;}
	if(!my.trigg_rain_fallspeed){my.trigg_rain_fallspeed = 20;}
	if(!my.trigg_snow_fallspeed){my.trigg_snow_fallspeed = 5;}
	if(!my.trigg_weather_fade_speed){my.trigg_weather_fade_speed = 10;}
	
	

	my.trigg_ID = trigg_num_off;
	trigg_num_off += 1;

	my.skill70 = weather_state;	
	my.skill71 = rain_random_move_on;
	my.skill72 = rain_random_move;
	my.skill73 = rain_wind_x;
	my.skill74 = rain_wind_y;
	my.skill75 = rain_fallspeed;
	my.skill76 = disable_lightning_thunder;
	my.skill77 = snow_random_move_on;
	my.skill78 = snow_random_move;
	my.skill79 = snow_wind_x;
	my.skill80 = snow_wind_y;
	my.skill81 = snow_fallspeed;
	my.skill82 = weather_fade_speed;	

	while(1)
	{
		if(vec_dist(my.x,camera.x) < my.trigg_range)
		{
			trigg_active_id = my.trigg_ID;
			
			if(my.trigg_rain == 1)
			{
				weather_state = 1;	
			}
			if(my.trigg_snow == 1)
			{
				weather_state = 2;	
			}
			if(my.trigg_snow == 0 && my.trigg_rain == 0)
			{
				weather_state = 0;	
			}
			
			weather_fade_speed = my.trigg_weather_fade_speed;
			
			if(weather_state > 0)
			{
				
				rain_random_move_on = my.trigg_rain_random_move_on;
				rain_random_move = my.trigg_rain_random_move;
				
				rain_wind_x = my.trigg_rain_wind_x;
				rain_wind_y = my.trigg_rain_wind_y;
				
				rain_fallspeed = my.trigg_rain_fallspeed;
				
				disable_lightning_thunder = my.trigg_disable_lightning_thunder;
				
				snow_random_move_on = my.trigg_snow_random_move_on;
				snow_random_move = my.trigg_snow_random_move;
				
				snow_wind_x = my.trigg_snow_wind_x;
				snow_wind_y = my.trigg_snow_wind_y;
				
				snow_fallspeed = my.trigg_snow_fallspeed;		
				
//				weather_fade_speed = my.trigg_weather_fade_speed;
			}
			
			if(my.trigg_fog_col_dist == 1)
			{
				func_fade_colors(d3d_fogcolor1,current_color,fog_col_trigg);
				
				fog_dist_near_trigg = my.trigg_fog_near;
				fog_dist_far_trigg= my.trigg_fog_far;
				
				if(camera.fog_start>fog_dist_near_trigg){
					camera.fog_start -= weather_fade_speed*time_step;
				}
				else{
					camera.fog_start += weather_fade_speed*time_step;
				}
				if(camera.fog_end>fog_dist_far_trigg){
					camera.fog_end -= weather_fade_speed*time_step;
				}
				else{
					camera.fog_end += weather_fade_speed*time_step;
				}
				
				fog_col_trigg.red = my.trigg_fog_red;
				fog_col_trigg.green = my.trigg_fog_green;
				fog_col_trigg.blue = my.trigg_fog_blue;
				
				
			}
		}else
		{
			if(trigg_active_id == my.trigg_ID)
			{
				trigg_active_id = -1;
				
				goto(act_mystymood_trigg_label1);	
				
			}
		}
		
		wait(1);	
	}

	act_mystymood_trigg_label1:
	
	weather_fader = 1;//reset this var

	weather_state = my.skill70;
	rain_random_move_on = my.skill71;
	rain_random_move = my.skill72;
	rain_wind_x = my.skill73;
	rain_wind_y = my.skill74;
	rain_fallspeed = my.skill75;
	disable_lightning_thunder = my.skill76;
	snow_random_move_on = my.skill77;
	snow_random_move = my.skill78;
	snow_wind_x = my.skill79;
	snow_wind_y = my.skill80;
	snow_fallspeed = my.skill81;
	weather_fade_speed = my.skill82;

	goto(act_mystymood_trigg_label2);	

}
