path "scripts";
path "models";
path "textures";

// Included files
include <mystymood.wdl>;


/////////////////////////////////////////////////////////////////
// Filename of the starting level.
string level_str = <mystymood_demo.wmb>; // give file names in angular brackets

var video_mode = 9;
var video_depth = 32;
var video_screen = 1;
var fps_max = 60;
var time_smooth = 0.99;
var clip_size = 0;
//var max_entities = 5000;

var terrain_chunk = 64;//I got fps problems using 32??


//var d3d_shaderversion = 0000;//uncoment for testing shader-fallback

bmap bmp_mystymood_logo = <mystymood_logo.jpg>;

font arial_font = "arial",1,25;
font arial_font_small = "arial",1,15;

panel splash1
{
	bmap = "bmp_mystymood_logo";
	flags = transparent;
	alpha = 100;
}

function splash_on()
{
	splash1.pos_x = screen_size.x/2 - bmap_width(bmp_mystymood_logo)/2;
	splash1.pos_y = screen_size.y/2 - bmap_height(bmp_mystymood_logo)/2;
	splash1.visible = on;
}

function splash_fade_out()
{
	
	while(1)
	{	
		if(splash1.alpha>0){
			splash1.alpha -= 8*time_step;
			if(splash1.alpha == 1){
				splash1.visible = off;
				bmap_purge(bmp_mystymood_logo);
				
				return;
			}
		}	
		wait(1);	
	}	
}

function main()
{	
	splash_on();
	freeze_mode = 1;
	level_load("mystymood_demo.wmb");
	wait(3);
	wait(-1);
	splash_fade_out();
	freeze_mode = 0;
	vec_set(d3d_lodfactor,vector(20,30,60));
}

//for testing!
action free_camera
{
	//	c_setminmax(my);

	var camera_force[3];
	my.invisible = on;
	my.polygon = on;
//	my.passable = on;

	camera_force.z = 0;
	vec_set(camera.x,my.x);
	vec_set(camera.pan,my.pan);

	while(1)
	{
		camera_force.x = (key_w - key_s)*10*time_step;
		camera_force.y = (key_a - key_d)*10*time_step;
		vec_add(my.pan,vector(mouse_force.x*(-7)*time_step,mouse_force.y*7*time_step,0));
		
		c_move(my,camera_force,nullvector,glide+ignore_passable+ignore_passents+ignore_push);
		vec_set(camera.x,vector(my.x,my.y,my.z+15));
		vec_set(camera.pan,my.pan);
		
		wait(1);
	}
}
